## Panduan Pengerjaan
Berikut adalah hal yang harus diperhatikan untuk pengumpulan tugas ini:
1. Buatlah grup pada Gitlab dengan format "IF3110-2023-01-XX", dengan XX adalah nomor kelompok (untuk K1 dan K2) atau kode kelompok (untuk K3).
2. Tambahkan anggota tim pada grup anda.
3. **Fork** pada repository ini dengan organisasi yang telah dibuat.
4. Ubah hak akses repository hasil Fork anda menjadi **private**.
5. Hal-hal yang harus diperhatikan.
   * Silakan commit pada repository anda (hasil fork)
   * Lakukan beberapa commit dengan pesan yang bermakna, contoh: “add register form”, “fix logout bug”, jangan seperti “final”, “benerin dikit”, “fix bug”.
   * Disarankan untuk tidak melakukan commit dengan perubahan yang besar karena akan mempengaruhi penilaian (contoh: hanya melakukan satu commit kemudian dikumpulkan).
   * Commit dari setiap anggota tim akan mempengaruhi penilaian.
   * Jadi, setiap anggota tim harus melakukan commit yang berpengaruh terhadap proses pembuatan aplikasi.
   * Sebagai panduan bisa mengikuti [semantic commit](https://gist.github.com/joshbuchea/6f47e86d2510bce28f8e7f42ae84c716).
6. Buatlah file README yang berisi:
   * Deskripsi aplikasi web
   * Daftar requirement
   * Cara instalasi
   * Cara menjalankan server
   * Screenshot tampilan aplikasi (tidak perlu semua kasus, minimal 1 per halaman), dan
   * Penjelasan mengenai pembagian tugas masing-masing anggota (lihat formatnya pada bagian pembagian tugas).

# Deskripsi aplikasi Web
Aplikasi web ini merupakan platform sharing music.

# Requirement
1. Docker

# Cara Instalasi
1. Lakukan git clone pada repository: https://gitlab.informatika.org/if3110-2023-01-33/tugas-besar-1.git.
2. Jalankan seluruh container (dijelaskan di bagian **Cara Menjalankan Server**).
3. Masuk ke postgresql melalui command berikut: psql -d web -U web  -h 127.0.0.1 -p 5432. Lalu masukkan password "web".
4. Jalankan script sql/initial-data.sql pada command line.

# Cara Menjalankan server
1. Masuk ke folder utama hasil git clone.
2. Jalankan command berikut: chmod +x ./scripts/build-image.sh && ./scripts/build-image.sh

# Screenshot
### Login
![Login](./images/login.png?raw=true)
### Register
![Register](./images/register.png?raw=true)
### Home
![Home](./images/home.png?raw=true)
### Daftar Album
![Daftar Album](./images/daftar_album.png?raw=true)
### Search, sort, filter
![Search, Sort, Filter](./images/filter_search_sort.png?raw=true)
### Edit lagu
![Edit lagu](./images/edit_lagu.png?raw=true)
### Detail Lagu
![Detail lagu](./images/detail_lagu.png?raw=true)
### Edit album
![Edit album](./images/edit_album.png?raw=true)
### Detail album
![Detail album](./images/detail_album.png?raw=true)
### Tambah lagu
![Tambah lagu](./images/tambah_lagu.png?raw=true)
### Tambah album
![Tambah album](./images/tambah_album.png?raw=true)
### Daftar user
![Daftar user](./images/daftar_user.png?raw=true)

# Pembagian tugas
_Server-side_  
Login: 13521163  
Register: 13521163  
Home: 13521128  
Daftar Album: 13521128  
Search, sort, filter: 13521128  
Edit lagu: 13521136  
Detail lagu: 13521136  
Edit album: 13521136  
Detail album: 13521136  
Tambah lagu: 13521163  
Tambah album: 13521163  
Daftar user: 13521128  
Object storage add: 13521163  
Object storage delete: 13521163  
Object storage edit: 13521136  

_Client-Side_  
Login: 13521163  
Register: 13521163  
Home: 13521128  
Daftar Album: 13521128  
Search, sort, filter: 13521128  
Edit lagu: 13521136  
Detail lagu: 13521136  
Edit album: 13521136  
Detail album: 13521136  
Tambah lagu: 13521163  
Tambah album: 13521163  
Daftar user: 13521128
