<?php

require_once 'db/db-executor.php';
require_once 'auth/authenticator.php';

$errMsg = '';


try {
    switch ($_SERVER['REQUEST_METHOD']) {
        case 'GET':
            // Get the full URL including additional parameters
            $fullUrl = $_SERVER['REQUEST_URI'];

            // Split the URL to separate the base route and parameters
            $parts = explode('?', $fullUrl);

            // Extract the base route (e.g., /album/fetch/)
            $baseRoute = $parts[0];

            // Extract and parse the query parameters
            $queryString = isset($parts[1]) ? $parts[1] : '';
            parse_str($queryString, $queryParams);

            // Extract individual parameters
            $csrfToken = $queryParams['csrf_token']; 
            $searchQuery = $queryParams['q']; 
            $sortBy = $queryParams['sort'];
            $order = $queryParams['order'];

            $creatorCondition = '';
            if ($queryParams['creator'] != 'all') {
                $creatorCondition = 'AND owner_account_id = '.$queryParams['creator'].'';
            }

            $limit = 6; 
            // $currentPage = $queryParams['current_page']; 

            // Prevent CSRF Attacks
            if(!authenticateToken($csrfToken)) {
                http_response_code(401);
                exit;
            }

            $query = 'SELECT *, account.username as username FROM album INNER JOIN account ON album.owner_account_id = account.account_id WHERE (album.name LIKE :searchQuery OR account.username LIKE :searchQuery) '.$creatorCondition.' ORDER BY '.$sortBy.' '.$order;

            $params = [
                'searchQuery' => '%'.$searchQuery.'%',
            ];

            $albumRes = execSelect($query, $params);

            // $query = 'SELECT * FROM album WHERE name LIKE :searchQuery LIMIT :limit OFFSET :offset';
            // $params = ['searchQuery' => $nameSearch, 'limit' => $limit, 'offset' => $currentPage];

            // $albumRes = execSelect($query, $params);

            
            $pages = execSelect('SELECT CEIL(COUNT(album_id) / :rows_per_page) AS page_count FROM album WHERE name LIKE :searchQuery',[ 'rows_per_page' => $limit, 'searchQuery' => '%'.$searchQuery.'%'])[0]['page_count'] + 1;

            $res = [
                'albums' => $albumRes,
                'pages' => $pages
            ];
            header('Content-Type: application/json');
            http_response_code(200);
            echo json_encode($res);
            exit;

            break;
        default:
            http_response_code(401);
            exit;
    }
} catch (Exception $e) {
    http_response_code($e->getCode());
    exit;
}
