<?php

require_once 'util/account-util.php';
require_once 'account/account-register.php';

$errMsg = '';

// check udh login blm
if (isset($_COOKIE['token'])) {
    header('Location: /', true, 303);
    exit();
}

if ($_SERVER["REQUEST_METHOD"] == "GET") {
    require 'presentation/account/register.view.php';
} else if ($_SERVER["REQUEST_METHOD"] == "POST") {
    if (!isset($_POST["username"]) || !isset($_POST["password"])) {
        header('Location: /403', true, 303);
        exit();
    }

    if (usernameExists($_POST["username"])) {
        $errMsg = 'Username already exists.';
        require 'presentation/account/register.view.php';
        exit();
    }

    if (!verifyCreds($_POST['username'], $_POST['password'])) {
        $errMsg = 'Invalid username/password, length must be < 30 and > 0.';
        require 'presentation/account/register.view.php';
        exit();
    }

    $username = $_POST['username'];
    $password = $_POST['password'];
    $isAdmin = isset($_POST['admin']) && $_POST['admin'] == 'on';
    $token = registerAccount($username, $password, $isAdmin);

    if (!$token) {
        header('Location: /500', true, 303);
        exit();
    }
    setcookie("token", $token, time() + 1 * 365 * 24 * 60 * 60, "/");
    header('Location: /', true, 303);
}