function isInt(num) {
    return !isNaN(num) && !isNaN(parseInt(num));
}

function validate() {
    let title = document.forms["form"]["title"].value;
    let albumId = document.forms["form"]["album"].value;
    let genre = document.forms["form"]["genre"].value;
    let year = document.forms["form"]["year"].value;
    let valid = true, errMsg = '';

    if (title === "" || year === "" || albumId === "" || genre === "") {
        console.log(title, year, albumId, genre)
        errMsg = "Please fill all the fields.";
        valid = false;
    }

    if (title.length > 255) {
        errMsg = "Album title must be less than 256 characters.";
        valid = false;
    }

    if (valid && (!isInt(albumId) || (isInt(albumId) && albumId < 0))) {
        errMsg = "Invalid album id";
        valid = false;
    }

    if (genre.length > 255) {
        errMsg = "Genre must be less than 256 characters.";
        valid = false;
    }

    if (valid && (!isInt(year) || (isInt(year) && year < 0))) {
        errMsg = "Invalid year";
        valid = false;
    }

    const fileSize = document.forms["form"]["input-file"].files[0].size / 1024 / 1024;
    if (fileSize > 120) {
        errMsg = "File size exceeds 120 MB limit";
        valid = false;
    }

    if (!valid) {
        document.getElementById('err-msg').textContent = errMsg;
    }
    return valid;
}