<?php

require_once 'util/album-finder.php';
require_once 'util/account-finder.php';

$name = "";
$artist = "";
$year = "";

$exists = false;

function populateFields($id): void {
    global $name, $artist, $year, $exists;

    $result = execSelect("SELECT * FROM album WHERE album_id = :id", ['id' => $id]);

    if (count($result) == 0) {
        return;
    }

    $name = $result[0]['name'];
    $artist = getAccountName($result[0]['owner_account_id']);
    $year = $result[0]['year'];

    $exists = true;
}

$id = $_GET['id'] ?? null;
if (is_numeric($id)) {
    populateFields($_GET['id']);
}

?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Edit Album</title>
    <script src="/presentation/music/edit/js/editAlbum.js" defer></script>
    <link rel="stylesheet" href="/presentation/music/edit/css/editAlbum.css">
    <link rel="stylesheet" type="text/css" href="/presentation/template/css/sidebar.css">
    <link rel="stylesheet" type="text/css" href="/presentation/template/css/navbar.css">
    <link rel="preconnect" href="https://fonts.googleapis.com%22%3E/">
    <link rel="preconnect" href="https://fonts.gstatic.com/" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@300;400;500&display=swap" rel="stylesheet">
</head>
<body>
<div class="wrapper">
    <?php require 'presentation/template/sidebar.php' ?>
    <div class="main-wrapper">
        <?php require 'presentation/template/navbar.php' ?>
        <p id="title">Edit Album</p>
        <div class="img-container">
            <img src="<?php if ($exists) echo getAlbumImage(); else echo '/presentation/music/edit/img/defalbum.jpg' ?>" alt="Album">
        </div>
        <div class="fields" id="form-d">
            <form id="form" method="post" enctype="multipart/form-data">
                <input type="text" class="input" id="input-title" name="name" placeholder="Album Title" value="<?php echo $name ?>">
                <input type="text" class="input" id="input-artist" name="artist" placeholder="Artist" value="<?php echo $artist ?>">
                <input type="text" class="input" id="input-year" name="year" placeholder="Year" value="<?php echo $year ?>">
                <input type="hidden" name="id" value="<?php echo $id ?>">
                <div id="file-sub">
                    <label id="input-label">Select album cover</label>
                    <input type="file" name="file" id="input-file" accept="image/jpeg, image/png">
                    <button type="button" id="file-r" hidden="hidden">Cancel</button>
                </div>
                <div id="submit-d">
                    <input type="submit" id="submit-b" value="Save">
                </div>
                <div class="aux-d" id="cancel-d">
                    <a href="javascript:history.back()" id="cancel-b">Cancel</a>
                </div>
                <div class="aux-d" id="delete-d">
                    <a href="<?php echo "javascript:deleteAlbum($id)" ?>" id="delete-b">Delete</a>
                </div>
            </form>
        </div>
    </div>
</div>
</body>
</html>