<?php

require_once 'util/account-finder.php';
require_once 'util/album-finder.php';

$title = "";
$artist = "";
$album = "";
$genre = "";
$year = "";
$filename = "";

$exists = false;

function populateFields($id): void {
    global $title, $artist, $album, $genre, $year, $filename, $exists;

    $result = execSelect("SELECT * FROM music WHERE music_id = :id", ['id' => $id]);

    if (count($result) == 0) {
        return;
    }

    $title = $result[0]['title'];
    $artist = getAccountName($result[0]['owner_account_id']);
    $album = getAlbumName($result[0]['album_id']);
    $genre = $result[0]['genre'];
    $year = $result[0]['year'];
    $filename = $result[0]['music_filename'];

    $exists = true;
}

$id = $_GET['id'] ?? null;
if (is_numeric($id)) {
    populateFields($_GET['id']);
}

?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Edit Music</title>
    <script src="/presentation/music/edit/js/editMusic.js" defer></script>
    <link rel="stylesheet" type="text/css" href="/presentation/music/edit/css/editMusic.css">
    <link rel="stylesheet" type="text/css" href="/presentation/template/css/sidebar.css">
    <link rel="stylesheet" type="text/css" href="/presentation/template/css/navbar.css">
    <link rel="preconnect" href="https://fonts.googleapis.com%22%3E/">
    <link rel="preconnect" href="https://fonts.gstatic.com/" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@300;400;500&display=swap" rel="stylesheet">
</head>
<body>
<div class="wrapper">
    <?php require 'presentation/template/sidebar.php' ?>
    <div class="main-wrapper">
        <?php require 'presentation/template/navbar.php' ?>
        <p id="title">Edit Music</p>
        <div class="img-container">
            <img src="<?php if ($exists) echo getAlbumImageFromMusic(); else echo '/presentation/music/edit/img/defalbum.jpg' ?>" alt="Album">
        </div>
        <div class="fields" id="form-d">
            <form method="post" id="form">
                <?php

                echo "<input type=\"text\" class=\"input\" id=\"input-title\" name=\"title\" placeholder=\"Title\" value=\"$title\">";
                echo "<input type=\"text\" class=\"input\" id=\"input-artist\" name=\"artist\" placeholder=\"Artist\" value=\"$artist\">";
                echo "<input type=\"text\" class=\"input\" id=\"input-album\" name=\"album\" placeholder=\"Album\" value=\"$album\">";
                echo "<input type=\"text\" class=\"input\" id=\"input-genre\" name=\"genre\" placeholder=\"Genre\" value=\"$genre\">";
                echo "<input type=\"text\" class=\"input\" id=\"input-year\" name=\"year\" placeholder=\"Year\" value=\"$year\">";
                echo "<input type=\"hidden\" id=\"input-id\" name=\"id\" value=\"$id\">";
                ?>
                <div id="submit-d">
                    <input type="submit" id="submit-b" value="Save">
                </div>
                <div class="aux-d" id="cancel-d">
                    <a href="javascript:history.back()" id="cancel-b">Cancel</a>
                </div>
                <div class="aux-d" id="delete-d">
                    <a href="<?php echo "javascript:deleteMusic('test', $id)" ?>" id="delete-b">Delete</a>
                </div>
            </form>
        </div>
    </div>
</div>
</body>
</html>
