const form = document.querySelector('#form');
const title = document.querySelector('#input-title');
const artist = document.querySelector('#input-artist');
const year = document.querySelector('#input-year');

const fileInput = document.querySelector('#input-file');
const cancelButton = document.querySelector('#file-r');

form.addEventListener('submit', (e) => {
    if (!title.value || !artist.value || !year.value) {
        e.preventDefault();
        alert('Please fill out all the required fields!');
    } else if (!Number.isInteger(parseInt(year.value)) || parseInt(year.value) < 0) {
        e.preventDefault();
        alert('Please enter a valid year!');
    }
});

fileInput.addEventListener('change', () => {
    if (fileInput.files.length > 0) {
        cancelButton.hidden = false;
    }
});

cancelButton.addEventListener('click', (e) => {
    e.preventDefault();
    fileInput.value = '';
    cancelButton.hidden = true;
});

function getCookie(name) {
    const value = `; ${document.cookie}`;
    const parts = value.split(`; ${name}=`);
    if (parts.length === 2) return parts.pop().split(';').shift();
}

function deleteAlbum(albumId) {
    if (!confirm('Are you sure you want to delete this album?')) {
        return;
    }

    let url = '/album/edit';
    let xhr = new XMLHttpRequest();

    let data = {
        account_id: getCookie('account_id'),
        id: albumId
    }

    xhr.open('DELETE', url, true);
    xhr.setRequestHeader('Content-Type', 'application/json');
    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4 && xhr.status === 200) {
            alert('Album deleted!');
        }
    }

    xhr.send(JSON.stringify(data));
}