const listItems = document.querySelector('#music-list').getElementsByTagName('li');
const editButtons = document.querySelector('#music-list').getElementsByClassName('edit-music');
const audioPlayer = document.querySelector('#audio');

for (let item of listItems) {
    item.addEventListener('click', (e) => {
        e.preventDefault();

        let id = item.id;

        let url = '/album';
        let xhr = new XMLHttpRequest();

        let data = {
            id: id
        }

        xhr.open('POST', url, true);
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.onreadystatechange = function() {
            if (xhr.readyState === 4 && xhr.status === 200) {
                let audio = JSON.parse(xhr.responseText);
                audioPlayer.src = audio.data;
                audioPlayer.hidden = false;
                audioPlayer.play();
            }
        }

        xhr.send(JSON.stringify(data));
    });
}

if (editButtons && editButtons.length > 0) {
    for (let item of editButtons) {
        item.addEventListener('click', (e) => {
            e.preventDefault();

            let id = item.id.substring(0, item.id.length - 2);

            window.location.href = '/music/edit?id=' + id;
        });
    }
}