<?php

require_once 'db/db-executor.php';
require_once 'auth/authenticator.php';
require_once 'auth/authorizer.php';

$errMsg = '';

// No token then login
if(!isset($_COOKIE['token'])) {
    header('Location: /login', true, 303);
    exit();
}

//Get id of account to verify user
$accountId = authenticateToken($_COOKIE['token']);

$allCreators = execSelect('SELECT DISTINCT username, account_id FROM account WHERE is_admin = CAST(1 AS SMALLINT)', []);


// Set limit and offset for pagination
$limit = 6;
$offset = 0;
// Get albums bsed on query
if(isset($_GET['q'])){
    $searchInput = $_GET['q'];
    $nameSearch = '%'.$searchInput.'%';
    $shownAlbums = execSelect('SELECT * FROM album WHERE name LIKE :searchQuery LIMIT :limit OFFSET :offset', ['searchQuery' => $nameSearch, 'limit' => $limit, 'offset' => $offset]);
    // Get pages number
    $pages = execSelect('SELECT CEIL(COUNT(album_id) / :rows_per_page) AS page_count FROM album WHERE name LIKE :searchQuery',[ 'rows_per_page' => $limit, 'searchQuery' => $nameSearch])[0]['page_count'];
} else{
    $shownAlbums = execSelect('SELECT * FROM album LIMIT :limit OFFSET :offset', ['limit' => $limit, 'offset' => $offset]);
    $pages = execSelect('SELECT CEIL(COUNT(album_id) / :rows_per_page) AS page_count FROM album',[ 'rows_per_page' => $limit])[0]['page_count'] + 1;
}

require 'presentation/music/list/albumList.view.php';