const searchInput = document.querySelector(".input-search");
const prevButton = document.querySelector("#previous");
const nextButton = document.querySelector("#next");
const buttonSearch = document.querySelector(".search");
const songsResult = document.querySelector(".music-wrapper");
const pagination = document.querySelector(".pagination");

// Sorting
const sortInput = document.querySelector(".sort-select");
const orderInput = document.querySelector(".order-select");
const genreInput = document.querySelector(".genre-select");
const creatorInput = document.querySelector(".creator-select");

const debounce = (func, delay) => {
    let timer;
    return (...args) => {
        clearTimeout(timer);
        timer = setTimeout(() => {
            func.apply(this, args);
        }, delay);
    };
};

let currentPage = 1;

searchInput &&
searchInput.addEventListener("keyup", 
    debounce(
        async (e) => {
            currentPage = 1;
            e.preventDefault();
            window.history.pushState(
                "",
                "",
                `/music-list?q=${searchInput.value}&sort=${sortInput.value}&order=${orderInput.value}&genre=${genreInput.value}&creator=${creatorInput.value}`
            );
            const xhr = new XMLHttpRequest();
            xhr.open(
                "GET",
                `/music/fetch/?csrf_token=${CSRF_TOKEN}&q=${searchInput.value}&sort=${sortInput.value}&order=${orderInput.value}&genre=${genreInput.value}&creator=${creatorInput.value}`
            );

            xhr.send();

            xhr.onreadystatechange = function () {
                if (this.readyState === XMLHttpRequest.DONE) {
                    data = JSON.parse(this.responseText);
                    console.log(data);
                    updateData(data);
                }
            };
            
        },
        500
    ));
 

buttonSearch &&
    buttonSearch.addEventListener("submit", async (e) => {
        currentPage = 1;
        e.preventDefault();
        window.history.pushState(
            "",
            "",
            `/music-list?q=${searchInput.value}&sort=${sortInput.value}&order=${orderInput.value}&genre=${genreInput.value}&creator=${creatorInput.value}`
        );
        const xhr = new XMLHttpRequest();
        xhr.open(
            "GET",
            `/music/fetch/?csrf_token=${CSRF_TOKEN}&q=${searchInput.value}&sort=${sortInput.value}&order=${orderInput.value}&genre=${genreInput.value}&creator=${creatorInput.value}`
        );

        xhr.send();

        xhr.onreadystatechange = function () {
            if (this.readyState === XMLHttpRequest.DONE) {
                data = JSON.parse(this.responseText);
                console.log(data);
                updateData(data);
            }
        };
    });

const updateData = (data) => {
    let newHTML = "";
    data.map((music) => {
        newHTML += `
        <div class="music" id=${music.album_id} >
            <img src="presentation/music/info/img/defalbum.jpg" alt="Playlist 1">
            <h3>${music.title}</h3>
            <p>By : ${music.username}</p>
            <p>Released : ${music.year}dsf</p>
            <p>ID : ${music.music_id}</p>
        </div>
        `;
    });
    songsResult.innerHTML = newHTML;
    songsResult.addEventListener("click", function (e) {
        const clickedElement = e.target;
        const musicElement = clickedElement.closest(".music");
        if (musicElement) {
            const musicId = musicElement.id;
            // Redirect 
            window.location.href = `/music?id=${musicId}`;
        }
    });
    
    pageNumber.innerHTML = currentPage;
    if (currentPage == 1) {
        prevButton.disabled = true;
    } else {
        prevButton.disabled = false;
    }

    if (currentPage == PAGES) {
        nextButton.disabled = true;
    } else {
        nextButton.disabled = false;
    }
};


const albums = document.querySelectorAll(".music");
albums.forEach((album) => {
    album.addEventListener("click", async (e) => {
        e.preventDefault();
        console.log(album.id);

        // Redirect to album page
        window.location.href = `/music?id=${album.id}`;
    });
});

