<?php

require_once 'db/db-executor.php';
require_once 'auth/authenticator.php';

$errMsg = '';

// No token then login
if(!isset($_COOKIE['token'])) {
    header('Location: /login', true, 303);
    exit();
}

$allGenres = execSelect('SELECT DISTINCT genre FROM music', []);
$allCreators = execSelect('SELECT DISTINCT username, account_id FROM account WHERE is_admin = CAST(1 AS SMALLINT)', []);


//Get id
$accountId = authenticateToken($_COOKIE['token']);
// Get music bsed on query
if(isset($_GET['q'])){
    $searchInput = $_GET['q'];
    $shownAlbums = execSelect('SELECT * FROM music WHERE title LIKE :searchQuery', ['searchQuery' => '%'.$searchInput.'%']);
} else{
    $shownAlbums = execSelect('SELECT * FROM music', []);
}


require 'presentation/music/list/musicList.view.php';