<?php

require 'auth/authenticator.php';

$uri = parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);

$routeMapNonLogin = [
    '/' => 'presentation/home/home.php',
    '' => 'presentation/home/home.php',
    '/login' => 'presentation/account/login.php',
    '/reg' => 'presentation/account/register.php',
    '/music' => 'presentation/music/info/musicInfo.php',
    '/album' => 'presentation/music/info/albumInfo.php',
    '/album-list' => 'presentation/music/list/albumList.php',
    '/music-list' => 'presentation/music/list/musicList.php',
    '/404' => 'presentation/notfound/404.php',
    '/500' => 'presentation/notfound/500.php',

    //For ajax
    '/album/fetch' => 'controller/albumController.php',
    '/music/fetch' => 'controller/musicController.php',
    '/users/fetch' => 'controller/userController.php',
];

$routeMapLogin = [
    '/music/add' => 'presentation/music/add/music.php',
    '/album/add' => 'presentation/music/add/album.php',
    '/music/edit' => 'presentation/music/edit/editMusic.php',
    '/album/edit' => 'presentation/music/edit/editAlbum.php',

    '/users' => 'presentation/account/userList.php',
    '/logout' => 'presentation/account/logout.php',
];

$uri = rtrim($uri, DIRECTORY_SEPARATOR);

if (array_key_exists($uri, $routeMapNonLogin)) {
    require $routeMapNonLogin[$uri];
    exit();
}

$exists = array_key_exists($uri, $routeMapLogin);
if ($exists && isset($_COOKIE['token']) && authenticateToken($_COOKIE['token'])) {
    require $routeMapLogin[$uri];
    exit();
}
if ($exists) {
    header('Location: /login?r='.$uri, true, 303);
    exit();
}

header('Location: /404', true, 303);